#include <cstdio>
#include <queue>
#include <vector>
#include <string>
#include <set>
using namespace std;

struct node {
    string s;
    int x1, y, t; 
    node(int x1, int y, int t, string s) : x1(x1), y(y), t(t), s(s) {}
};

bool operator<(const node &n1, const node &n2) {
    if (n1.t != n2.t) return n1.t > n2.t;
    if (n1.x1 != n2.x1) return n1.x1 < n2.x1;
    return n1.y > n2.y;
}

struct block { int x1,x2,y; };

int pw;
bool overlap(block &b,node &t) {
    if (t.x1 > b.x1 && t.x1 < b.x2) return true;
    if (t.x1 + pw > b.x1 && t.x1 + pw < b.x2) return true;
    if (b.x1 > t.x1 && b.x1 < t.x1 + pw) return true;
    if (b.x2 > t.x1 && b.x2 < t.x1 + pw) return true;
    if (t.x1 + pw / 2 > b.x1 && t.x1 + pw / 2 < b.x2) return true;
    if (b.x1 + (b.x2 - b.x1) / 2 > t.x1 && b.x1 + (b.x2 - b.x1) / 2 < t.x1 + pw) return true;
    return false;
}

int main() {
    int n;
    scanf(" %d",&n);
    while (n--) {
        int px1,px2,py;
        int tx1,tx2,ty;
        scanf(" %d %d %d",&px1,&px2,&py);
        pw = px2 - px1;
        vector<block> blocks;
        for (;;) {
            block b;
            scanf(" %d %d %d",&b.x1,&b.x2,&b.y);
            if (b.x1 == -1) break;
            blocks.push_back(b);
        }
        priority_queue<node> q;
        q.push(node(px1,py,0,""));
        set<pair<int,int> > cache;
        bool valid = false;
        while (!q.empty()) {
            node top = q.top(); q.pop();
            if (cache.count(make_pair(top.x1,top.y))) continue;
            cache.insert(make_pair(top.x1,top.y));
//            printf("%d,%d,%d,%s\n",top.x1,top.y,top.t,top.s.c_str());
            bool hit = false;
            for (int i=0; i<blocks.size(); i++) {
                if (blocks[i].y == top.y && overlap(blocks[i], top)) {
                    if (i == 0) {
                        for (int i=0;i<top.s.size();i++) if (top.s[i]!='D') printf("%c",top.s[i]);
                        printf("\n");
                        valid = true;
                        break;
                    }
                    if (top.s[top.s.size()-1] == 'W')
                        q.push(node(blocks[i].x1-pw, top.y, top.t+top.x1-(blocks[i].x1-pw), top.s));
                    else
                        q.push(node(blocks[i].x1-pw, top.y, top.t+top.x1-(blocks[i].x1-pw), top.s+"W"));
                    if (top.s[top.s.size()-1] == 'E')
                        q.push(node(blocks[i].x2, top.y, top.t+blocks[i].x2-top.x1, top.s));
                    else
                        q.push(node(blocks[i].x2, top.y, top.t+blocks[i].x2-top.x1, top.s+"E"));
                    hit = true;
                }
            }
            if (!hit && !valid) {
                int topy = -2000000000, ind;
                for (int i=0; i<blocks.size(); i++) {
                    if (overlap(blocks[i], top) &&
                        blocks[i].y < top.y) {
                        topy = max(topy, blocks[i].y);
                        ind = i;
                    }
                }
                if (topy == -2000000000) continue;
                if (ind == 0) {
                    for (int i=0;i<top.s.size();i++) if (top.s[i]!='D') printf("%c",top.s[i]);
                    printf("\n");
                    valid = true;
                }
                q.push(node(top.x1, topy, top.t+top.y-topy, top.s+"D"));
            }
            if (valid) break;
        }
        if (!valid) {
            printf("GATOR BAIT\n");
        }
    }
    return 0;
}